package function

import (
	"gitlab.smartblocklab.com/smartcontracts/sc-security/tools"
	"gitlab.smartblocklab.com/smartcontracts/sc-security/actions"
	"github.com/hyperledger/fabric/core/chaincode/shim"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"gitlab.smartblocklab.com/smartcontracts/common/model"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
)

func IsOfferApproved_Function(operationID string, adapter chaincode.StubInterfaceAdapter) bool {
	logger.Infof("Invoke: OfferCC.IsOfferApproved {operationID: %s}", operationID)

	isOfferApprovedArg := model.IsOfferApprovedArg{
		OperationID: operationID,
	}

	resp := tools.SignedInvokeChaincode(adapter, invoke.OfferIsApprovedChannel, actions.Actions().OfferCC().IsOfferApproved, isOfferApprovedArg)
	return resp.Status == int32(shim.OK)
}