package function

import (
	"gitlab.smartblocklab.com/smartcontracts/sc-security/tools"
	"gitlab.smartblocklab.com/smartcontracts/sc-security/actions"
	"github.com/hyperledger/fabric/core/chaincode/shim"
	"encoding/json"
	"fmt"
	"errors"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"gitlab.smartblocklab.com/smartcontracts/common/model"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
)

type CheckExistsTransactionByList_Type func(syncRequest model.SyncRequest, adapter chaincode.StubInterfaceAdapter) (*model.CheckExistsResult, error)

func CheckExistsTransactionByList_Function(syncRequest model.SyncRequest, adapter chaincode.StubInterfaceAdapter) (*model.CheckExistsResult, error) {

	resp := tools.SignedInvokeChaincode(adapter, invoke.CheckExistsTransactionByListChannel, actions.Actions().TransactionCC().CheckExistsTransactionByList, syncRequest)

	if resp.Status != int32(shim.OK) {
		logger.Errorf("Error %s", resp.Message)
		return nil, errors.New(resp.Message)
	}

	var checkExistsResult model.CheckExistsResult
	err := json.Unmarshal(resp.Payload, &checkExistsResult)
	if err != nil {
		errMsg := fmt.Sprintf("Failed to deserialize, due to %s", err)
		logger.Error(errMsg)
		return nil, err
	}

	return &checkExistsResult, nil
}
